package ch.zhaw.projekt2.turnierverwaltung;

import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import org.junit.jupiter.api.Test;
import org.mockito.InOrder;
import org.mockito.Mockito;
import java.io.IOException;

import static org.junit.jupiter.api.Assertions.fail;
import static org.mockito.Mockito.inOrder;

public class FactoryDecoratorTest {

    private FactoryDecorator factoryDecorator;

    @Test
    void test() {
        FileIO io = Mockito.mock(FileIO.class);
        Factory fc = Mockito.mock(Factory.class);
        Pane pn = Mockito.mock(BorderPane.class);
        FileIO.TournamentFile tf = Mockito.mock(FileIO.TournamentFile.class);

        factoryDecorator = new FactoryDecorator(io,fc,pn);
        factoryDecorator.openTournament(tf);

        InOrder order = inOrder(io,fc,pn);

        try {
            order.verify(fc).setTournament(io.loadTournament(tf));
            order.verify(fc).showGameScheduler((BorderPane) pn);

        } catch (IOException | ClassNotFoundException e) {
            e.printStackTrace();
            fail();
        }
    }
}
